<?xml version="1.0"?>
<xsl:stylesheet
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:doc="http://nwalsh.com/xsl/documentation/1.0"
  exclude-result-prefixes="doc"
  version="1.0">

  <doc:chapter xmlns="">
    <chapterinfo>
      <releaseinfo role="meta">
  $Id: test.xsl,v 1.3 2001/03/30 04:00:59 injektilo Exp $
      </releaseinfo>
      <author>
  <surname>Ball</surname>
  <firstname>Steve</firstname>
      </author>
      <copyright>
  <year>2001</year>
  <holder>Steve Ball</holder>
      </copyright>
    </chapterinfo>

    <title>XSLT Standard Library Test Suite</title>

    <section>
      <title>About The Test Suite</title>

      <para>This stylesheet tests the stylesheet modules contained in the XSLT Standard Library</para>
    </section>
    <section>
      <title>Running The Tests</title>

      <para>Process the <filename>test.xml</filename> file with the stylesheet <filename>test.xsl</filename> using your favourite XSLT processor.  The result is a text document.  When the tests fail they print a text message, so no news is good news!  Messages are also printed to the console, which is useful for finding those templates which are hanging.</para>
    </section>
  </doc:chapter>

  <xsl:include href="string.test.xsl"/>
  <xsl:include href="date-time.test.xsl"/>

  <xsl:output method="text"/>

  <xsl:template match="tests">
    <xsl:message>Tests starting</xsl:message>
    <xsl:text>Running stylesheet tests

</xsl:text>

    <!-- TODO: generate this stylesheet so that modules to be tested
       - are automatically determined.
      -->

    <xsl:call-template name="string"/>
    <xsl:call-template name="date-time"/>
<!--
    <xsl:call-template name="html"/>
    <xsl:call-template name="fo"/>
-->

  </xsl:template>

  <xsl:template match="module">

    <!-- <xsl:call-template name="{@name}"/> -->

  </xsl:template>

  <xsl:template name="test">
    <xsl:param name="expect"/>
    <xsl:param name="result"/>
    <xsl:param name="description">(no description)</xsl:param>

    <xsl:if test="$expect != $result">
      <xsl:text>Test </xsl:text>
      <xsl:value-of select="$description"/>
      <xsl:text> failed.
Result was:
</xsl:text>
      <xsl:value-of select="$result"/>
      <xsl:text>
Result should have been:
</xsl:text>
      <xsl:value-of select="$expect"/>
    </xsl:if>
  </xsl:template>

</xsl:stylesheet>
